leetcode python   28.实现strStr()   35. 搜索插入位置

https://leetcode-cn.com/problems/implement-strstr/description/
这题本质是要写kmp,但因为python功能比较强大,直接能判断两个字符串是否相等的功能,所以可以偷懒AC。
之后还是要重新看下KMP算法

class Solution(object):
    def searchInsert(self, nums, target):
        """
        :type nums: List[int]
        :type target: int
        :rtype: int
        """
        if target > nums[-1]:
          return len(nums)
        if target < nums[0]:
          return 0
        for i in range(len(nums)):
          if nums[i] == target:
            return i
        for i in range(len(nums) - 1):
          if nums[i] < target and nums[i + 1] > target:
            return i + 1

还有用python的find函数更快

class Solution(object):
    def strStr(self, haystack, needle):
        """
        :type haystack: str
        :type needle: str
        :rtype: int
        """
        if not len(needle):
            return 0
        i=haystack.find(needle)
        return i

https://leetcode-cn.com/problems/search-insert-position/description/
这题是找适当的位置,插入元素。
这种有序数组,第一应该想到的就是二分查找,可惜我完全没想到,只是循环一遍做完的,这种做法毫无意义,刷算法题还是要想着优化才可以,尤其是这种水题。
二分查找里面还有各种变体问题,比如说出现重复元素,之后还是要看下二分查找的细节。
这里贴一个这题最快的二分查找。

class Solution(object):
    def searchInsert(self, nums, target):
        """
        :type nums: List[int]
        :type target: int
        :rtype: int
        """

        left, right = 0, len(nums) - 1
        while left <= right:
            mid = (left + right) / 2
            if target < nums[mid]:
                right = mid - 1
            elif target > nums[mid]:
                left = mid + 1
            else:
                return mid

        if mid == left:
            return mid
        else:
            return mid + 1

你可能感兴趣的:(Leetcode)